package org.netkernel.lang.dpml.ast.impl;

import org.netkernel.lang.dpml.ast.IValue;
import org.netkernel.request.IResponseMeta;

public class ValueImpl implements IValue
{
	private final Object mRepresentation;
	private final IResponseMeta mMeta;
	
	public ValueImpl(Object aRepresentation, IResponseMeta aMeta)
	{	mRepresentation = aRepresentation;
		mMeta = aMeta;
	}
	
	public Object getRepresentation()
	{	return mRepresentation;
	}
	
	public IResponseMeta getMeta()
	{	return mMeta;
	}
	
	public boolean equals(Object aOther)
	{	boolean result = aOther instanceof ValueImpl;
		if (result)
		{	ValueImpl other = (ValueImpl)aOther;
			if (mRepresentation==null)
			{	result = other.mRepresentation==null;
			}
			else
			{	result = mRepresentation.equals(other.mRepresentation);
			}
		}
		return result;
	}
}
