package org.netkernel.lang.dpml.ast.impl;

import org.netkernel.lang.dpml.ast.ILocation;
import org.netkernel.lang.dpml.ast.IScope;
import org.netkernel.lang.dpml.ast.IVariable;
import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.nkf.NKFException;

public class VariableImpl implements IVariable
{
	private final String mName;
	private final IScope mScope;
	private final ILocation mLocation;
	
	public static final String ANON_PREFIX="_";
	
	public VariableImpl(String aName, IScope aScope, ILocation aLocation)
	{	mName=aName;
		mScope=aScope;
		mLocation=aLocation;
	}
	
	public String getName()
	{	return mName;
	}

	public boolean isAnonymous()
	{	return mName.startsWith(ANON_PREFIX);
	}

	public IScope getScope()
	{	return mScope;
	}

	public ILocation getLocation()
	{	return mLocation;
	}
	
	public void close(INKFRequestContext aContext) throws NKFException
	{
	}


}
