package org.netkernel.lang.dpml.endpoint;

import org.netkernel.layer0.meta.impl.SourcedArgumentMetaImpl;
import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.nkf.INKFResponseReadOnly;
import org.netkernel.module.standard.endpoint.StandardAccessorImpl;

public class IfAccessor extends StandardAccessorImpl
{
	public IfAccessor()
	{	declareThreadSafe();
		declareUnhandledExceptionsExpired(false);
		declareArgument(new SourcedArgumentMetaImpl("cond", null, null, new Class[]{Boolean.class}));
	}
	
	public void onSource(INKFRequestContext aContext) throws Exception
	{
		boolean cond = aContext.source("arg:cond",Boolean.class).booleanValue();
		Class representationClass = aContext.getThisRequest().getRepresentationClass();
		INKFResponseReadOnly subResp=null;
		if (cond)
		{	if (aContext.getThisRequest().argumentExists("then"))
			{	subResp=aContext.sourceForResponse("arg:then",representationClass);
			}
		}
		else
		{	if (aContext.getThisRequest().argumentExists("else"))
			{	subResp=aContext.sourceForResponse("arg:else",representationClass);
			}
		}
		if (subResp!=null)
		{	aContext.createResponseFrom(subResp);
		}
	}
}
