package org.netkernel.lang.dpml.endpoint;

import org.netkernel.layer0.meta.impl.SourcedArgumentMetaImpl;
import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.nkf.INKFRequestReadOnly;
import org.netkernel.layer0.nkf.INKFResponseReadOnly;
import org.netkernel.module.standard.endpoint.StandardAccessorImpl;

public class SwitchAccessor extends StandardAccessorImpl
{
	public SwitchAccessor()
	{	declareThreadSafe();
		declareUnhandledExceptionsExpired(false);

		declareArgument(new SourcedArgumentMetaImpl("cond", "if true following \"when\" is evaluated", null, new Class[]{Boolean.class}));
		declareArgument(new SourcedArgumentMetaImpl("then", "evaluated when previous \"cond\" is true", null, null));
		declareArgument(new SourcedArgumentMetaImpl("otherwise", "evaluated if no conditions are true", null, null));
	}
	
	public void onSource(INKFRequestContext aContext) throws Exception
	{
		INKFRequestReadOnly thisReq=aContext.getThisRequest();
		boolean condTrue=false;
		for (int i=0; i<thisReq.getArgumentCount(); i++)
		{	String argName=thisReq.getArgumentName(i);
			String argValue=thisReq.getArgumentValue(i);
			if (argName.equals("cond"))
			{	condTrue=aContext.source(argValue, Boolean.class);
			}
			else if (argName.equals("then"))
			{	if (condTrue)
				{	INKFResponseReadOnly respIn=aContext.sourceForResponse(argValue, thisReq.getRepresentationClass());
					aContext.createResponseFrom(respIn);
					break;
				}
			}
			else if (argName.equals("otherwise"))
			{	INKFResponseReadOnly respIn=aContext.sourceForResponse(argValue, thisReq.getRepresentationClass());
				aContext.createResponseFrom(respIn);
				break;
			}
		}
	}
}
